package xyz.lychee.lagfixer.libs.adventure.platform.facet;

import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public abstract class FacetBase<V> implements Facet<V> {
   protected final Class<? extends V> viewerClass;

   protected FacetBase(final @Nullable Class<? extends V> viewerClass) {
      this.viewerClass = viewerClass;
   }

   public boolean isSupported() {
      return this.viewerClass != null;
   }

   public boolean isApplicable(final @NotNull V viewer) {
      return this.viewerClass != null && this.viewerClass.isInstance(viewer);
   }
}
